//
function p_gravi(PARTICLE* p)
{
	p.vel_z -= 0.5;
	p.alpha -= 2*time_step;
	if (p.alpha <= 0) p.lifespan = 0;
}
function p_agravi(PARTICLE* p)
{
	p.vel_z += 0.5;
	p.vel_x *= 1.05;
	p.vel_y *= 1.05;
	p.alpha -= 5*time_step;
	if (p.alpha <= 0) p.lifespan = 0;
}
function explode(PARTICLE* p)
{
	//var tv[3];
	vec_set(p.vel_x,vector(random(8)-4,random(8)-4,random(4)));
	p.red = 250;
	p.green = 100;
	p.blue = 50;
	p.bmap = pmap;
	p.alpha = 35 + random(15);
	p.flags |= (BRIGHT|MOVE);
	p.event = p_gravi;
}
function explode3(PARTICLE* p)
{
	//var tv[3];
	vec_set(p.vel_x,vector(random(10)-5,random(10)-5,random(16)+8));
	p.red = 150;
	p.green = 150;
	p.blue = 150;
	p.bmap = pmap;
	p.alpha = 45 + random(25);
	p.flags |= (BRIGHT|MOVE);
	p.event = p_gravi;
}
function heal(PARTICLE* p)
{
	//var tv[3];
	vec_set(p.vel_x,vector(random(8)-4,random(8)-4,random(2)+2));
	p.red = 50;
	p.green = 150;
	p.blue = 250;
	p.bmap = pmap;
	p.alpha = 35 + random(15);
	p.flags |= (BRIGHT|MOVE);
	p.event = p_agravi;
}
function sk_heal()
{
	my.jclass = jc_art;
	wait(1);
	you = ptr_for_handle(my.skill9);
	you.hp += my.skill10;
	effect(heal,100,you.x,nullvector);
	ent_remove(me);
}
//
function sk_rkt()
{
	my.jclass = jc_art;
	wait(1);
	you = ptr_for_handle(my.skill9);
	while (!is(my,FLAG1))
	{
		if (you != NULL)
		{
			if (vec_dist(my.x,you.x)>10)
			{
				vec_set(tvec,you.x);
				vec_sub(tvec,my.x);
				vec_normalize(tvec,minv(vec_dist(my.x,you.x),10));
				vec_add(my.x,tvec);
				if (!is(my,FLAG2)) vec_to_angle(my.pan,tvec); else vec_set(my.pan,camera.pan);
			}
			else
			{
				you.hp -= my.skill10*(1+random(my.skill11));
				if (is(my,FLAG3)) you.ap -= my.skill12 * (0.5 + random(1));
				set(my,FLAG1);
			}
		}
		else
		{
			set(my,FLAG1);
		}
		wait(1);
	}
	effect(explode,100,my.x,nullvector);
	ent_remove(me);
}

function sk_rktp()
{
	vec_fill(my.scale_x,0.15);
	vec_set(my.pan,camera.pan);
	set(my,LIGHT|BRIGHT|FLAG2);
	vec_set(my.blue,vector(0,255,192));
	sk_rkt();
}
function sk_rktv()
{
	vec_fill(my.scale_x,0.15);
	vec_set(my.pan,camera.pan);
	set(my,LIGHT|BRIGHT|FLAG2|FLAG3);
	vec_set(my.blue,vector(0,0,255));
	sk_rkt();
}

function sk_urust()
{
	my.jclass = jc_art;
	vec_fill(my.scale_x,0.2);
	vec_set(my.pan,camera.pan);
	set(my,LIGHT|BRIGHT);
	vec_set(my.blue,vector(0,255,0));
	wait(1);
	you = ptr_for_handle(my.skill9);
	while (!is(my,FLAG1))
	{
		if (you != NULL)
		{
			vec_set(tvec,you.x);
			vec_sub(tvec,my.x);
			vec_normalize(tvec,minv(vec_dist(my.x,you.x),10));
			if (vec_dist(my.x,you.x)>10)
			{
				vec_add(my.x,tvec);
				vec_set(my.pan,camera.pan);
			}
			else
			{
				you.hp -= my.skill10*(1+random(my.skill11));
				vec_add(you.x,tvec);you.move_x = you.x;you.move_y = you.y;
				you.apm -= my.skill12 * (0.5 + random(1));
				set(my,FLAG1);
			}
		}
		else
		{
			set(my,FLAG1);
		}
		wait(1);
	}
	effect(explode,100,my.x,nullvector);
	ent_remove(me);
}