#include <acknex.h>
#include <default.c>
#include "BattleDefines.c"
//
BMAP* art = "skillart.png";BMAP* art_teamcolor = "teamcolor.png";
BMAP* art_move = "btn_move.png";BMAP* art_sel = "btn_sel.png";
BMAP* art_cancel = "btn_cancel.png";BMAP* art_targetpoint = "btn_target1.png";
BMAP* mousemap = "arrow_r.png";BMAP* mousemap1 = "arrow_g.png";BMAP* mousemap2 = "arrow_w.png";
//
SOUND* snd_select = "laser1.wav";
ENTITY* esel;ENTITY* tmpe;ENTITY* tmpe2;ENTITY* tmpe3;
STRING* tstr = "#40";STRING* skilltip = "#40";
var mousemode,done,mouseleft,a,c,mgood,gteam,aicount,plcount,aidone,skillrow;var glevel;
VECTOR tvec, tvec2, ctg, cds, cng;
function spawnlevel(glevel);
//
#include "BattleArt.c"
#include "BattleSystemDataBase.c"
//
PANEL* uui = {
	bmap = "box2.png";
	alpha = 75;
}
//
function ang360(angle)
{
	while (angle >= 360) { angle -= 360; }
	while (angle < 0) { angle += 360; }
	return angle;
}
function var_rotate(ang1,ang2,speed)
{
	var fi1,fi2;
	fi1 = ang360(ang1);fi2 = ang360(ang2);
	if (fi1<fi2)
	{if (fi1 < fi2-180) fi1 -= speed;else fi1 += speed;}
	if (fi1>fi2)
	{if (fi1 > fi2+180) fi1 += speed; else fi1 -= speed;}
	if (abs(fi1 - fi2)<speed) fi1 = fi2;
    return fi1;
}
//
function draw_button(BMAP* art,VECTOR* draw_xy,alpha)
{
	draw_quad(art,draw_xy,NULL,NULL,NULL,NULL,alpha,0);
	if (mouse_pos.x>draw_xy.x&&mouse_pos.y>draw_xy.y&&mouse_pos.x<draw_xy.x+48&&mouse_pos.y<draw_xy.y+48)
	{
		draw_quad(art_sel,draw_xy,NULL,NULL,NULL,NULL,alpha*0.7,0);
		if (mouseleft) result = 2; else result = 1;
	}
	else
	{
		result = 0;
	}
	return result;
}
function draw_buttonext(id,VECTOR* draw_xy,alpha)
{
	draw_quad(art,draw_xy,vector(sdb_img[id].x*48,sdb_img[id].y*48,0),vector(48,48,0),NULL,NULL,alpha,0);
	if (mouse_pos.x>draw_xy.x&&mouse_pos.y>draw_xy.y&&mouse_pos.x<draw_xy.x+48&&mouse_pos.y<draw_xy.y+48)
	{
		str_cpy(skilltip,(sdb_name.pstring)[id]);
		draw_quad(art_sel,draw_xy,NULL,NULL,NULL,NULL,alpha*0.7,0);
		if (mouseleft) result = 2; else result = 1;
	}
	else
	{
		result = 0;
	}
	return result;
}
//
function mouse_to_level()
{
	VECTOR vecFrom;VECTOR vecTo;
	vec_set(vecFrom,vector(mouse_cursor.x,mouse_cursor.y,10));
	vec_for_screen(vecFrom,camera);
	vec_set(vecTo,vector(mouse_cursor.x,mouse_cursor.y,5000));
	vec_for_screen(vecTo,camera);
	return(c_trace(vecFrom,vecTo,IGNORE_PASSABLE|USE_POLYGON));
}
//
function draw_line3d_ext(VECTOR* mmx,VECTOR* c,ENTITY* e)
{
	VECTOR t_v;
	if (mmx.x < 0) t_v.x = e.min_x; else t_v.x = e.max_x;
	if (mmx.y < 0) t_v.y = e.min_y; else t_v.y = e.max_y;
	if (mmx.z < 0) t_v.z = e.min_z; else t_v.z = e.max_z;
	t_v.x += mmx.x / 10;
	t_v.y += mmx.y / 10;
	t_v.z += mmx.z / 10;
	vec_rotate(t_v,e.pan);
	vec_add(t_v,e.x);
	t_v.z += 0.25;
	draw_line3d(t_v,c,100);
}

function draw_boundingbox(ENTITY* e,VECTOR* c)
{
	draw_line3d_ext(vector(-1,-1,-1),NULL,e);		draw_line3d_ext(vector(-1,-1,-1),c,e);
	draw_line3d_ext(vector( 1,-1,-1),c,e);			draw_line3d_ext(vector( 1, 1,-1),c,e);
	draw_line3d_ext(vector(-1, 1,-1),c,e);			draw_line3d_ext(vector(-1,-1,-1),c,e);
	draw_line3d_ext(vector(-1,-1,1),NULL,e);		draw_line3d_ext(vector(-1,-1,1),c,e);
	draw_line3d_ext(vector( 1,-1,1),c,e);			draw_line3d_ext(vector( 1, 1,1),c,e);
	draw_line3d_ext(vector(-1, 1,1),c,e);			draw_line3d_ext(vector(-1,-1,1),c,e);
	draw_line3d_ext(vector(-1,-1,-1),NULL,e);		draw_line3d_ext(vector(-1,-1,-1),c,e);
	draw_line3d_ext(vector(-1,-1,1),c,e);
	draw_line3d_ext(vector( 1,-1,-1),NULL,e);		draw_line3d_ext(vector( 1,-1,-1),c,e);
	draw_line3d_ext(vector( 1,-1,1),c,e);
	draw_line3d_ext(vector(-1, 1,-1),NULL,e);		draw_line3d_ext(vector(-1, 1,-1),c,e);
	draw_line3d_ext(vector(-1, 1,1),c,e);
	draw_line3d_ext(vector( 1, 1,-1),NULL,e);		draw_line3d_ext(vector( 1, 1,-1),c,e);
	draw_line3d_ext(vector( 1, 1,1),c,e);
}
//

function l_camera()
{
	while (1)
	{
		draw_text("Press space to end turn & give the control to computer player.",16,740,vector(55,255,155));
		mouse_to_level();
		if (you != NULL)
		{
			if (you.jclass == jc_unit) draw_boundingbox(you,vector(0,192,255));
		}
		if (esel != NULL) {
			if (esel != you) draw_boundingbox(esel,vector(0,255,192));
			draw_quad(uui.bmap,nullvector,NULL,NULL,NULL,NULL,75,0);
			draw_text(esel.string1,115,6,vector(255,255,255));
			draw_text(esel.string2,115,26,vector(255,255,255));
			str_cpy(tstr,"");str_cat_num(tstr,"%.0f/",esel.hp);
			str_cat_num(tstr,"%.0f",esel.hpm);draw_text(tstr,80,47,vector(255,255,255));
			str_cpy(tstr,"");str_cat_num(tstr,"%.0f/",esel.ap);
			str_cat_num(tstr,"%.0f",esel.apm);draw_text(tstr,265,47,vector(255,255,255));
			done = 0;
			draw_quad(art_teamcolor,vector(360,5,0),vector(esel.team*24-24,0,0),vector(24,24,0),NULL,NULL,75,0);
			if (esel.team == gteam) {
			//
			if (mousemode == -1 && done==0)
			{
				mouse_to_level();
				vec_set(tvec2,vector(esel.x,esel.y,esel.z+esel.min_z+1));
				if (vec_dist(esel.x,vector(target.x,target.y,esel.z))<minv(esel.move_max,esel.ap))
				{
					mgood = 2;mouse_map = mousemap1;
					vec_set(tvec,vector(0,255,0));
				}
				else
				{
					mgood = 1;mouse_map = mousemap2;
					vec_set(tvec,vector(0,0,255));
				}
				draw_line3d(tvec2,NULL,95);
				draw_line3d(tvec2,tvec,95);
				draw_line3d(vector(target.x,target.y,tvec2.z),tvec,95);
				draw_button(art_cancel,vector(10,90,0),90);
				if (result > 0) str_cpy(skilltip,"Cancel");
				if (result > 1) {mousemode = 0;done = 1;}
				draw_button(art_targetpoint,vector(58,90,0),90);
				if (result > 0) str_cpy(skilltip,"Targettype: Point");
			}
			if (mousemode > 0 && done==0)
			{
				//mouse_map = mousemap;
				draw_button(art_cancel,vector(10,90,0),90);
				if (result > 0) str_cpy(skilltip,"Cancel");
				if (result > 1) {mousemode = 0;done = 1;}
				draw_quad(art,vector(58,90,0),vector(sdb_tsr[esel.skill[mousemode+49]].x*48-48,48,0),vector(48,48,0),NULL,NULL,90,0);
				if (sdb_tsr[esel.skill[mousemode+49]].x==ttype_unit)
				{
					mouse_to_level();
					if (you.jclass==jc_unit&&you!=esel&&
					vec_dist(esel.x,you.x)<=sdb_tsr[esel.skill[mousemode+49]].z&&
					esel.ap >= sdb_apc[esel.skill[mousemode+49]].x)
					{
						mgood = 2;mouse_map = mousemap1;
					}
					else
					{
						mgood = 1;mouse_map = mousemap2;
					}
				}
			}
			if (mousemode == 0 && done==0)
			{
				mouse_map = mousemap;
				if (esel.ap > 0 && esel.move_max > 0)
				{
					draw_button(art_move,vector(10,90,0),90);
					a = 1;
					if (result > 0) str_cpy(skilltip,"Move");
					if (result > 1) {mousemode = -1;done = 1;}
					while (a <= 10)
					{
						if (esel.skill[a+49]>0)
						{
							draw_buttonext(esel.skill[a+49],vector(10+a*48,90,0),90);
							if (result > 1)
							{
								done = 1;
								mousemode = a;
							}
						}
						a += 1;
					}
				}
			}
			draw_text(skilltip,175,68,vector(255,255,255));
			}
		}
		vec_set(tvec,cds);
		vec_rotate(tvec,cng);
		vec_add(tvec,ctg);
		vec_set(camera.x,tvec);
		vec_set(camera.pan,cng);
		if (mouse_right)
		{
			if (!mouse_middle)
			{
				vec_set(tvec,vector(-mouse_force.y,mouse_force.x,0));
				vec_scale(tvec,cds.x/100);
				vec_rotate(tvec,vector(cng.x,0,0));
				vec_add(ctg,tvec);
			}
			else
			{
				cds.x = maxv(minv(cds.x*(1+mouse_force.y*0.04),-128),-960);
			}
		}
		else
		{
			if (mouse_middle)
			{
				cng.x = cycle(cng.x+mouse_force.x*2,-180,180);
				cng.y = clamp(cng.y-mouse_force.y,-90,-5);
			}
		}
		mouseleft = 0;
		str_cpy(skilltip,"");
		wait(1);
	}
}
//
function aue_anim()
{
	while (!is(my,FLAG1))
	{
		if (my.anm_i == 0)
		{
			my.anm_v = cycle(my.anm_v+1,0,100);
			ent_animate(me,"stand",my.anm_v,ANM_CYCLE);
		}
		if (my.anm_i == 1)
		{
			my.anm_v = cycle(my.anm_v+my.move_speed,0,100);
			ent_animate(me,"walk",my.anm_v,ANM_CYCLE);
		}
		if (my.anm_i == 3)
		{
			my.anm_v = minv(my.anm_v+1,100);
			ent_animate(me,"attack",my.anm_v,ANM_CYCLE);
			if (my.anm_v==100) my.anm_i = 0;
		}
		wait(1);
	}
}
function aue_position()
{
	while (!is(my,FLAG1))
	{
		my.pan = var_rotate(my.pan,my.my_pan,my.move_speed*1.7+2);
		if (vec_dist(my.x,vector(my.move_x,my.move_y,my.z))>my.move_speed)
		{
			vec_set(tvec,vector(my.move_x,my.move_y,my.z));
			vec_sub(tvec,my.x);
			vec_normalize(tvec,minv(vec_dist(my.x,vector(my.move_x,my.move_y,my.z)),my.move_speed));
			my.x += tvec.x;
			my.y += tvec.y;
			vec_to_angle(tvec2,tvec);
			my.my_pan = tvec2.x;
			my.anm_i = 1;
		}
		else if (my.anm_i == 1) my.anm_i = 0;
		wait(1);
	}
}
//

function a_unitengine()
{
	wait(1);
	if (my.team == 2)
	{
		vec_set(my.blue,vector(150,150,150));set(my,LIGHT);
	}
	my.jclass = jc_unit;
	my.hp = my.hpm;
	my.ap = my.apm;
	c_setminmax(me);
	set(my,NOFILTER);
	c_trace(my.x,vector(my.x,my.y,my.z-1100),IGNORE_ME|IGNORE_PASSABLE|USE_BOX);
	vec_set(my.x,vector(target.x,target.y,target.z-my.min_z));
	my.move_x = my.x+random(32)-16;my.move_y = my.y+random(32)-16;
	aue_anim();
	aue_position();
	while (!is(my,FLAG1))
	{
		if (my.hp <= 0) set(my,FLAG1);
		my.hp = minv(my.hp,my.hpm);
		my.ap = clamp(my.ap,0,my.apm);
		wait(1);
	}
	if (esel==me) {esel = NULL;mousemode = -2;}
	if (!is(my,FLAG2))
	{
		effect(explode3,1000,my.x,nullvector);
	}
	//
	ent_remove(me);
}

function u_nova()
{
	my.string1 = "Novamech";
	my.string2 = "Basic support/sniper unit";
	my.hpm = 500;
	my.apm = 200;
	my.jindex = 11;
	my.move_max = 128;
	my.move_speed = 2;
	my.skill51 = 2;
	my.skill52 = 4;
	my.skill53 = 1;
	a_unitengine();
}
function u_tech()
{
	my.string1 = "Battletech";
	my.string2 = "Basic siege unit";
	my.hpm = 600;
	my.apm = 200;
	my.jindex = 11;
	my.move_max = 128;
	my.move_speed = 2;
	my.skill52 = 1;
	my.skill51 = 3;
	a_unitengine();
}
function u_drag()
{
	my.string1 = "Rad7";
	my.string2 = "Advanced siege unit";
	my.hpm = 2400;
	my.apm = 500;
	my.jindex = 11;
	my.move_max = 50;
	my.move_speed = 2;
	my.skill51 = 5;
	my.skill52 = 3;
	my.skill53 = 4;
	a_unitengine();
}

function a_terrain()
{
	my.jclass = jc_terrain;
	set(my,NOFILTER | POLYGON);
}

function mlb()
{
	mouseleft = 1;
	if (mouse_pos.x < 400 && mouse_pos.y < 150) return;
	if (mousemode == -2)
	{
		mouse_to_level();
		if (you.jclass==jc_unit)
		{
			esel = you;
			mousemode = 0;
		}
		return;
	}
	if (mousemode == -1 && mgood > 1)
	{
		mouse_to_level();
		if (you.jclass==jc_terrain)
		{
			esel.move_x = target.x;
			esel.move_y = target.y;
			esel.ap -= vec_dist(vector(target.x,target.y,esel.z),esel.x);
			mousemode = 0;
		}
		return;
	}
	if (mousemode > 0)
	{
		mouse_to_level();
		if (sdb_tsr[esel.skill[mousemode+49]].x==ttype_unit && mgood>1)
		{
			a = minv(esel.ap,sdb_apc[esel.skill[mousemode+49]].z);
			esel.ap -= a;
			vec_set(tvec,you.x);vec_sub(tvec,esel.x);vec_to_angle(tvec2,tvec);
			esel.my_pan = tvec2.x;
			esel.anm_i = 3;esel.anm_v = 0;
			str_cpy(tstr,(sdb_mdl.pstring)[esel.skill[mousemode+49]]);
			tmpe = ent_create(tstr,esel.x,sdb_cmd[esel.skill[mousemode+49]]);
			vec_set(tmpe.skill10,sdb_var[esel.skill[mousemode+49]]);
			tmpe.skill9 = handle(you);
			tmpe.skill10 *= a / sdb_apc[esel.skill[mousemode+49]].y;
			if (esel.ap == 0) mousemode = 0;
		}
		return;
	}
	if (mousemode == 0)
	{
		mouse_to_level();
		if (you.jclass==jc_terrain)
		{
			esel = NULL;
			mousemode = -2;
		}
		if (you.jclass==jc_unit)
		{
			esel = you;
		}
		return;
	}
}

function findunit(uteam,dist)
{
	ENTITY* te;ENTITY* te2;
	te = ent_next(NULL);
	te2 = NULL;
	while (te != NULL)
	{
		if (te.team == uteam && te != you)
		{
			if (te2 == NULL)
			{
				te2 = te;
			}
			else
			{
				if (vec_dist(you.x,te.x)<vec_dist(you.x,te2.x) ||
				(vec_dist(you.x,te.x)<vec_dist(you.x,te2.x)+128&&te.hp<te2.hp ) )
				{
					te2 = te;
				}
			}
		}
		te = ent_next(te);
	}
	if (te2!=NULL)
	{
		if (vec_dist(you.x,te2.x)<=dist) tmpe2 = te2; else tmpe2 = NULL;
	}
	else
	{
		tmpe2 = NULL;
	}
}

function aiskill()
{
	if (you == NULL) return;
	if (skillrow == 0)
	{
		if (sdb_tsr[you.skill[a+49]].y == style_damage)
		{
			findunit(1,sdb_tsr[you.skill[a+49]].z);
		}
		if (sdb_tsr[you.skill[a+49]].y == style_heal)
		{
			findunit(2,sdb_tsr[you.skill[a+49]].z);skillrow += 1;
		}
		if (you.ap>=sdb_apc[you.skill[a+49]].x && tmpe2 != NULL)
		{	
			c = minv(you.ap,sdb_apc[you.skill[a+49]].z);
			you.ap -= c;
			vec_set(tvec,tmpe.x);vec_sub(tvec,you.x);vec_to_angle(tvec2,tvec);
			you.my_pan = tvec2.x;
			you.anm_i = 3;you.anm_v = 0;
			str_cpy(tstr,(sdb_mdl.pstring)[you.skill[a+49]]);
			tmpe3 = ent_create(tstr,you.x,sdb_cmd[you.skill[a+49]]);
			vec_set(tmpe3.skill10,sdb_var[you.skill[a+49]]);
			tmpe3.skill9 = handle(tmpe2);
			tmpe3.skill10 *= c / sdb_apc[you.skill[a+49]].y;/**/
			wait(-0.5);
			aiskill();
		}
		else
		{
			aidone = 1;
		}
	}
	else aidone = 1;
}

function aicycle()
{
	you = ent_next(NULL);
	while (you != NULL)
	{
		if (you.jclass == jc_unit && you.team == 1) you.ap = you.apm;
		you = ent_next(you);
	}
	gteam = 0;
	aicount = 0;plcount = 0;
	you = ent_next(NULL);
	while (you != NULL)
	{
		if (you.jclass == jc_unit && you.team == 2)
		{
			aicount += 1;
			tmpe = ptr_for_handle(you.skill7);
			if (tmpe == NULL) you.skill7 = 0;
			tmpe2 = ent_next(NULL);
			tmpe3 = NULL;
			while (tmpe2 != NULL)
			{
				if (tmpe2.team == 1)
				{
					if (tmpe3 == NULL)
					{
						tmpe3 = tmpe2;
					}
					else
					{
						if (vec_dist(you.x,tmpe2.x)<vec_dist(you.x,tmpe3.x) ||
						(vec_dist(you.x,tmpe2.x)<vec_dist(you.x,tmpe3.x)+128&&tmpe2.hp<tmpe3.hp ) )
						{
							tmpe3 = tmpe2;
						}
					}
				}
				tmpe2 = ent_next(tmpe2);
			}
			if (tmpe3 != NULL)
			{
				tmpe = tmpe3;
				you.skill7 = handle(tmpe);
				if (vec_dist(you.x,tmpe.x)>70)
				{
					vec_set(tvec,tmpe.x);
					vec_sub(tvec,you.x);
					vec_normalize(tvec,minv(minv(you.move_max,you.ap),vec_dist(you.x,tmpe.x)-90));
					you.ap -= minv(minv(you.move_max,you.ap),vec_dist(you.x,tmpe.x)-90);
					vec_add(tvec,you.x);
					you.move_x = tvec.x;you.move_y = tvec.y;
				}
				wait(-1);
				a = 1;
				while (a <= 10)
				{
					
					if (you.skill[a+49]>0)
					{
						aidone = 0;
						skillrow = 0;
						aiskill();
						while (aidone == 0) wait(1);
					}
					a += 1;
				}
				//
			}
		}
		else
		{
			if (you.jclass == jc_unit && you.team == 1)
			{
				plcount += 1;
			}
		}
		you = ent_next(you);
	}
	you = ent_next(NULL);
	while (you != NULL)
	{
		if (you.jclass == jc_unit && you.team == 2) you.ap = you.apm;
		you = ent_next(you);
	}
	var t1,t2;
	t1 = 0;t2 = 0;
		you = ent_next(NULL);
		while (you != NULL)
		{
			if (you.jclass == jc_unit)
			{
				if (you.team == 1) t1 += 1;
				if (you.team == 2) t2 += 1;
			}
			you = ent_next(you);
		}
		if (t1 == 0)
		{
			spawnlevel(glevel);
		}
		if (t2 == 0)
		{
			glevel += 1;
			spawnlevel(glevel);
		}
	gteam = 1;
}

function keyspace()
{
	//if (gteam==1) gteam=2; else gteam=1;
	aicycle();
}

function clearlevel()
{
	esel = NULL;mousemode = -2;
	you = ent_next(NULL);
	while (you != NULL)
	{
		if (you.jclass == jc_unit) set(you,FLAG1 | FLAG2);
		you = ent_next(you);
	}
}

function spawnlevel(lvl)
{
	var slt;
	slt = 90;
	clearlevel();
	switch (lvl)
	{
		case 0:
		tmpe=ent_create("M2.mdl",vector(128,-64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M1.mdl",vector(128,64,128),u_tech);tmpe.team = 1;
		tmpe=ent_create("M1.mdl",vector(-128,64,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M2.mdl",vector(-128,-64,128),u_nova);tmpe.team = 2;
			break;
		case 1:
		//tmpe=ent_create("M2.mdl",vector(128,-64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M1.mdl",vector(128,0,128),u_tech);tmpe.team = 1;
		tmpe=ent_create("M1.mdl",vector(-128,0,128),u_tech);tmpe.team = 2;
			break;
		case 2:
		tmpe=ent_create("M1.mdl",vector(-128,-64,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M1.mdl",vector(-128,64,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M1.mdl",vector(-128,0,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M2.mdl",vector(128,-64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M1.mdl",vector(128,64,128),u_tech);tmpe.team = 1;
			break;
		case 3:
		tmpe=ent_create("M1.mdl",vector(-128,-32,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M1.mdl",vector(-128,32,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M1.mdl",vector(-128,-96,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M1.mdl",vector(-128,96,128),u_tech);tmpe.team = 2;
		tmpe=ent_create("M2.mdl",vector(128,-64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M2.mdl",vector(128,64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M2.mdl",vector(128,0,128),u_nova);tmpe.team = 1;
			break;
		case 4:
		tmpe=ent_create("M3.mdl",vector(-128,0,128),u_drag);tmpe.team = 2;
		tmpe=ent_create("M2.mdl",vector(160,-64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M2.mdl",vector(160,64,128),u_nova);tmpe.team = 1;
		tmpe=ent_create("M1.mdl",vector(128,0,128),u_tech);tmpe.team = 1;
			break;
		case 5:
		while (1)
		{
			draw_text("Congratulations!\nYou completed this small techdemo.\nIf you want to see more of this gaming, vote for it!
			...
			Imagine the game that you will get if I'll get higher edition.",25,25,vector(255,255,255));
			wait(1);
		}
			break;
	}
	while (slt > 0)
	{
		draw_text((levelnames.pstring)[glevel],63,148,vector(0,0,0));
		draw_text((levelnames.pstring)[glevel],65,148,vector(0,0,0));
		draw_text((levelnames.pstring)[glevel],64,147,vector(0,0,0));
		draw_text((levelnames.pstring)[glevel],64,149,vector(0,0,0));
		draw_text((levelnames.pstring)[glevel],64,148,vector(255,255,255));
		draw_text((levelnames.pstring)[glevel],64,148,vector(255,255,255));
		slt -= 1;
		wait(1);
	}
}

function main()
{
	initdb();
	media_play("dawn.mid",NULL,75);
	video_switch(8,0,1);
	mouse_map = mousemap;
	mouse_range = 7500;
	mousemode = -2;
	mouse_mode = 4;
	shadow_stencil = 2;
	detail_size = 25;
	vec_set(cds,vector(-400,0,0));
	vec_set(cng,vector(30,-45,0));
	level_load("sky.mdl");//load nothing - our terrain has action
	wait(3);//it was said that it's not needed, but it still causes lag if removed
	draw_textmode("Times",0,22,75);
	ent_create("T1.mdl",nullvector,a_terrain);//create our level -> terrain object
	glevel = 0;spawnlevel(glevel);
	l_camera();
	gteam = 1;
	on_mouse_left = mlb;
	on_space = keyspace;
}